<template>
  <AppPopover
    :trigger="'click'"
    class="user-actions-popover-wrapper"
    :class="{ '_no-login': !auth }"
    :options="popoverOptions">
    <template slot="tooltip-trigger">
      <slot
        v-if="!auth"
        name="entry-item"/>
      <!--      TODO: Сложный для понимания ИМХо какой-то компонент. Стоит подумать как его упростить-->
      <AppButton
        v-if="!$slots['entry-item'] || auth"
        :classes="['userActionsTrigger', '_transparent', 'buttonLogin']"
        :class="{'-in-fixed-header': isFixedHeader}"
        @click.native="login">
        <span
          slot="button-item"
          class="button-item">
          <span
            class="user-text"
            v-if="!auth">
            Войти
          </span>
          <template v-else>
            <span
              class="user-text _circle __bold"
              v-tooltip="accountTooltip">
              {{ displayedName }}
            </span>
            <span class="user-text _mobile __hide-shadow">
              <img
                v-if="auth.isOrganization"
                svg-inline
                src="~/assets/svg/redesign/avatar-company.svg">
              <img
                v-else
                svg-inline
                src="~/assets/svg/redesign/avatar-user.svg">
              <span class="user-text-name">{{ auth.displayedName }}</span>
            </span>
          </template>

        </span>
      </AppButton>
    </template>
    <template
      v-if="auth"
      slot="tooltip-content">
      <AppUserMenu
        :auth="auth"
        @logout="$emit('logout')"/>
    </template>
  </AppPopover>

</template>

<script>
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppPopover from '~/components/redesign/app-tooltip/app-popover';
import AppUserMenu from '~/components/redesign/app-user/app-user-menu';

export default {
  name: 'AppUserActions',
  components: {
    AppButton,
    AppPopover,
    AppUserMenu,
  },
  props: {
    auth: {
      type: Object,
      default() { return null; },
    },
    isFixedHeader: {
      type: Boolean,
      default: false,
    },
    container: {
      type: String,
      default: '.userActionsTrigger',
    },
  },
  computed: {
    popoverOptions() {
      return {
        trigger: 'click',
        enabled: Boolean(this.auth),
        container: this.container,
        additionalClasses: ['userActionsPopover', '-custom-scroll'],
      };
    },
    hasProfileOrganization() {
      return Boolean(this.auth) && Boolean(this.auth.isOrganization);
    },
    displayedName() {
      return this.auth && this.auth.displayedName[0].toLocaleUpperCase();
    },
    accountTooltip() {
      return {
        content: `<div> <span>${this.auth.displayedName}</span> </div>`,
        placement: 'bottom',
        html: true,
        trigger: 'hover',
        offset: 8,
        classes: 'tooltipDark',
        delay: 0,
      };
    },
  },
  methods: {
    login() {
      if (!this.auth) {
        this.$emit('login');
      }
    },
  },
};
</script>

<style lang="postcss">

.appHeader .userActionsPopover {
  @media screen and ( min-width: 981px ) {
    top: 100% !important;
    min-width: 14.4rem;
    right: auto !important;
    left: -10.65rem!important;
    transform: none !important;
    border-top-left-radius: 0;
    border-top-right-radius: 0;
    box-shadow: 0 3px 3px rgba(0, 0, 0, .1);
  }
}

.mainPage .userActionsPopover {
  @media screen and ( min-width: 981px ) {
    top: 100% !important;
    left: auto !important;
    right: -2rem !important;
    transform: none !important;
    min-width: 14rem;
    margin-left: -2rem;
  }
}

.appHeader,
.mainPage {
  @media screen and ( max-width: 980px ) {
    .user-actions-popover-wrapper {
      width: 100%;
    }
    .userActionsPopover {
      position: fixed !important;
      top: 0 !important;
      left: 0 !important;
      transform: none !important;
      display: flex;
      flex-direction: column;
      justify-content: flex-end;
      width: 100vw;
      min-width: 20rem;
      height: 100vh;
      border-radius: 0;
      border: none;
      background-color: var(--bg-wrapper);

      .tooltip-inner {
        padding: 1rem 0 calc(2rem + var(--mobile-browser-bar));
        max-height: 100vh;
        background-color: var(--bg-main);
        overflow-y: auto;
      }
    }
  }
}


.user-actions-popover-wrapper {
  display: flex;
  flex-direction: column;
  justify-content: center;
  .trigger {
    height: 100%;
    display: flex !important;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    .userActionsTrigger {
      height: 100%;
    }
  }
  .button-icon-arrow-down {
    transition: all 0.3s;
  }
  &.open .button-icon-arrow-down {
    transform: rotateZ(180deg);
  }

  &._no-login .userActionsPopover{
    display: none;
  }

  .userActionsTrigger {
    position: relative;

    &.button .button-item:not(:last-child) {
      padding-bottom: 0;
    }

    &.buttonLogin {
      font-size: .75rem;
      color: var(--header-link-color);

      &.-in-fixed-header {
        color: var(--color-main-lightest);

        &:hover {
          color: var(--color-main);
        }

        @media screen and ( min-width: 981px ) {
          .user-text._circle {
            background-color: var(--header-button-bg);
            color: var(--bg-main);
          }
        }
        @media screen and ( max-width: 980px ) {
          color: var(--header-link-color);
          &:hover {
            color: var(--header-link-color);
          }
        }
      }

      & .user-text {
        position: relative;

        &._circle {
          display: inline-flex;
          align-items: center;
          justify-content: center;
          width: 1.75rem;
          height: 1.75rem;
          font-family: var(--font-heading);
          font-size: 0.875rem;
          font-weight: var(--font-weight-bold);
          color: var(--header-button-bg);
          border-radius: 50%;
          background-color: var(--bg-main);
        }

        &._mobile {
          display: none;
        }
      }

      @media only screen and ( max-width: 980px ) {
        width: 100%;
        .button-item {
          display: flex;
          justify-content: center;
          width: 100%;
          overflow: hidden;
        }
        .user-text {
          &._mobile {
            position: relative;
            display: inline-flex;
            align-items: center;
            justify-content: center;
            line-height: 1.4;
            &.__hide-shadow {
              margin-right: -3rem;
              padding-right: 3rem;
              width: calc(100% + 3rem);
              overflow: hidden;
              &:after {
                width: 5rem;
                background-image: linear-gradient(270deg, var(--bg-darktset) 3rem, var(--bg-transparent));
              }
            }

            .user-text-name {
              display: inline-flex;
              max-width: calc(100% - 2.25rem);
            }

            .svg.svgAvatar {
              flex-shrink: 0;
              width: 1.75rem;
              height: 1.75rem;
              margin-right: 0.5rem;
              border-radius: 50%;
              background-color: var(--bg-main);
              fill: var(--footer-mobile-bg);
            }
          }
          &._circle {
            display: none;
          }
        }
      }
    }
  }
}

</style>
